// DbolewrapCtl.cpp: Implementierung der CDbolewrapCtrl-ActiveX-Steuerelementklasse.

/*
dbolewrap - OLE Wrapper
Version: 0.1
Author: gunter _dot_ coelle _at_ dbaudio _dot_ com
Copyright: d&b audiotechnik AG, Gunter Coelle
License: GPL, see LICENSE.TXT
*/


#include "stdafx.h"
#include <ole2.h>
#include "dbolewrap.h"
#include "DbolewrapCtl.h"
#include "DbolewrapPpg.h"
#include "afxconv.h"
#include "atlconv.h"
#include "Utils.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CDbolewrapCtrl, COleControl)


// Global Variable for Parameter Array
#define	MAX_PARAMS 20
VARIANT Params[MAX_PARAMS] ;


/////////////////////////////////////////////////////////////////////////////
// Nachrichtenzuordnungstabelle

BEGIN_MESSAGE_MAP(CDbolewrapCtrl, COleControl)
	//{{AFX_MSG_MAP(CDbolewrapCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch-Tabelle

BEGIN_DISPATCH_MAP(CDbolewrapCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CDbolewrapCtrl)
	DISP_FUNCTION(CDbolewrapCtrl, "CreateObjectByName", CreateObjectByName, VT_BOOL, VTS_PVARIANT VTS_BSTR)
	DISP_FUNCTION(CDbolewrapCtrl, "CreateObjectByClassId", CreateObjectByClassId, VT_BOOL, VTS_PVARIANT VTS_BSTR)
	DISP_FUNCTION(CDbolewrapCtrl, "DestroyObject", DestroyObject, VT_BOOL, VTS_PVARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "SetParam", SetParam, VT_BOOL, VTS_I4 VTS_VARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "CallMethod", CallMethod, VT_BOOL, VTS_PVARIANT VTS_PVARIANT VTS_BSTR VTS_I4)
	DISP_FUNCTION(CDbolewrapCtrl, "SetProperty", SetProperty, VT_BOOL, VTS_PVARIANT VTS_BSTR VTS_VARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "ArrayCreate", ArrayCreate, VT_BOOL, VTS_PVARIANT VTS_I4)
	DISP_FUNCTION(CDbolewrapCtrl, "ArraySetElement", ArraySetElement, VT_BOOL, VTS_PVARIANT VTS_I4 VTS_VARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "SetParamFromVar", SetParamFromVar, VT_BOOL, VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "ArraySetElementFromVar", ArraySetElementFromVar, VT_BOOL, VTS_PVARIANT VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "GetProperty", GetProperty, VT_BOOL, VTS_PVARIANT VTS_BSTR VTS_PVARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "ArrayGetElement", ArrayGetElement, VT_BOOL, VTS_PVARIANT VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CDbolewrapCtrl, "GetVariantType", GetVariantType, VT_I4, VTS_PVARIANT)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CDbolewrapCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Ereignistabelle

BEGIN_EVENT_MAP(CDbolewrapCtrl, COleControl)
	//{{AFX_EVENT_MAP(CDbolewrapCtrl)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Eigenschaftenseiten

BEGIN_PROPPAGEIDS(CDbolewrapCtrl, 1)
	PROPPAGEID(CDbolewrapPropPage::guid)
END_PROPPAGEIDS(CDbolewrapCtrl)


/////////////////////////////////////////////////////////////////////////////
// Klassenerzeugung und GUID initialisieren

IMPLEMENT_OLECREATE_EX(CDbolewrapCtrl, "DBOLEWRAP.DbolewrapCtrl.1",
	0x22df72ae, 0x49a6, 0x4c18, 0xa0, 0x87, 0x62, 0x6, 0x5e, 0xfa, 0x37, 0x7f)


/////////////////////////////////////////////////////////////////////////////
// Typbibliothek-ID und Version

IMPLEMENT_OLETYPELIB(CDbolewrapCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Schnittstellen-IDs

const IID BASED_CODE IID_DDbolewrap =
		{ 0x9f49a2cc, 0x978, 0x4508, { 0xb6, 0xa1, 0x65, 0x6b, 0xf8, 0xec, 0x96, 0x31 } };
const IID BASED_CODE IID_DDbolewrapEvents =
		{ 0xedfd3595, 0x31d9, 0x486a, { 0xab, 0x30, 0xeb, 0x51, 0x6a, 0xb8, 0xb7, 0x22 } };


/////////////////////////////////////////////////////////////////////////////
// Steuerelement-Typinformation

static const DWORD BASED_CODE _dwDbolewrapOleMisc =
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CDbolewrapCtrl, IDS_DBOLEWRAP, _dwDbolewrapOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl::CDbolewrapCtrlFactory::UpdateRegistry -
// Fgt Eintrge der Systemregistrierung fr CDbolewrapCtrl hinzu oder entfernt diese

BOOL CDbolewrapCtrl::CDbolewrapCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_DBOLEWRAP,
			IDB_DBOLEWRAP,
			afxRegApartmentThreading,
			_dwDbolewrapOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl::CDbolewrapCtrl - Konstruktor

CDbolewrapCtrl::CDbolewrapCtrl()
{
	
	InitializeIIDs(&IID_DDbolewrap, &IID_DDbolewrapEvents);
	
	// Initialize COM for this thread...
	CoInitialize (NULL);
	int i;
	for (i=0; i<MAX_PARAMS; i++) {
		VariantInit (&Params[i]);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl::~CDbolewrapCtrl - Destruktor

CDbolewrapCtrl::~CDbolewrapCtrl()
{
	// Uninitialize COM for this thread... 
	CoUninitialize (); 
}


/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl::OnDraw - Zeichenfunktion

void CDbolewrapCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	pdc->Ellipse(rcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl::DoPropExchange - Untersttzung dauerhafter Eigenschaften

void CDbolewrapCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

}


/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl::OnResetState - Setzt das Steuerelement in den Standardzustand zurck

void CDbolewrapCtrl::OnResetState()
{
	COleControl::OnResetState();  // Setzt die Standards zurck, die in DoPropExchange gefunden wurden
}


/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl::AboutBox - Ein Dialogfeld "Info" fr den Benutzer anzeigen

void CDbolewrapCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_DBOLEWRAP);
	dlgAbout.DoModal();
}




/////////////////////////////////////////////////////////////////////////////
// CDbolewrapCtrl Behandlungsroutinen fr Nachrichten 

BOOL CDbolewrapCtrl::CreateObjectByName (VARIANT FAR* ClassVar, LPCTSTR ObjectName) 
{
	// Get CLSID for our server... 
	CLSID clsid;
	USES_CONVERSION;
		
	HRESULT hr = CLSIDFromProgID (T2COLE(ObjectName), &clsid);

	if (FAILED (hr)) {
		::MessageBox (NULL, "CLSIDFromProgID() failed", "Error", 0x10010);
		return FALSE; 
	} 

	// Start server and get IDispatch...

	IDispatch  *idApp ;

	
	hr = CoCreateInstance (clsid, NULL, CLSCTX_ALL, IID_IDispatch, (void**) &idApp);
	if (FAILED(hr)) {
		::MessageBox (NULL, "Program not registered properly", "Error", 0x10010);
		return FALSE;
	}

	VariantInit (ClassVar) ;
	ClassVar->pdispVal = idApp ;
	ClassVar->vt = VT_DISPATCH ;
	
	return TRUE;
}

BOOL CDbolewrapCtrl::CreateObjectByClassId(VARIANT FAR* ClasssVar, LPCTSTR ObjectId) 
{
	return TRUE;
}

BOOL CDbolewrapCtrl::DestroyObject(VARIANT FAR* ClassVar) 
{
	if (!_CheckVariant (ClassVar, "ClassVar"))
		return FALSE ;
	
	return TRUE;
}

BOOL CDbolewrapCtrl::SetParam(long Index, const VARIANT FAR& Value) 
{
	if ((Index > MAX_PARAMS) || (Index < 1)){
		::MessageBox (NULL, "Index out of bounds", "Error", 0x10010);
		return FALSE ;
	}
	
	VariantClear   (&Params[MAX_PARAMS - Index]);
	VariantCopyInd (&Params[MAX_PARAMS - Index], (struct tagVARIANT*) &Value);
	return TRUE;
}


BOOL CDbolewrapCtrl::CallMethod(VARIANT FAR* ReturnVar, VARIANT FAR* ClassVar, LPCTSTR MethodName, long NoOfParams) 
{
	USES_CONVERSION;
	DISPPARAMS DispParams = {NULL, NULL, 0, 0} ;

	if (NoOfParams > MAX_PARAMS) {
		::MessageBox (NULL, "Max Number of Parameters exceeded", "Error", 0x10010);
		return FALSE ;
	}
	if (!_CheckClassVar (ClassVar, "ClassVar"))
		return FALSE ;
	

	VariantInit (ReturnVar) ;

	IDispatch *idApp ;

	idApp = ClassVar->pdispVal;
	idApp->AddRef (); 

	LPOLESTR osMethodName ;
	osMethodName = T2OLE (MethodName) ;

	if (NoOfParams > 0) {
		DispParams.rgvarg = &Params [MAX_PARAMS - NoOfParams] ;
	}
	DispParams.cArgs = NoOfParams ;

	

	if (!_DispInvokeByName (idApp, osMethodName, DISPATCH_METHOD, &DispParams, ReturnVar)) {
		return FALSE ;
	}
	return TRUE;
}


BOOL CDbolewrapCtrl::SetProperty(VARIANT FAR* ClassVar, LPCTSTR PropertyName, const VARIANT FAR& PropertyValue) 
{
	USES_CONVERSION;
	IDispatch *idApp ;
	DISPID dispidNamed = DISPID_PROPERTYPUT;
	DISPPARAMS DispParams = {NULL, NULL, 0, 0} ;

	if (!_CheckClassVar (ClassVar, "ClassVar"))
		return FALSE ;
	
		
	idApp = ClassVar->pdispVal; 
	
	LPOLESTR osPropertyName ;
	osPropertyName = T2OLE (PropertyName) ;

	VariantInit (&Params[0]);
	VariantCopyInd (&Params[0], (struct tagVARIANT*) &PropertyValue);


	DispParams.cArgs = 1 ;
	DispParams.rgvarg = &Params[0] ;
	DispParams.cNamedArgs = 1;
	DispParams.rgdispidNamedArgs = &dispidNamed;


	if (!_DispInvokeByName (idApp, osPropertyName, DISPATCH_PROPERTYPUT, &DispParams, NULL)) {
		return FALSE ;
	}
	return TRUE;
}


BOOL CDbolewrapCtrl::ArrayCreate(VARIANT FAR* ArrVar, long NoOfElements) 
{
	SAFEARRAYBOUND arraybound [1] ;
	arraybound[0].lLbound = 0;
	arraybound[0].cElements = NoOfElements ;


	VariantInit (ArrVar);

	ArrVar->vt = VT_ARRAY | VT_VARIANT; 
	ArrVar->parray = SafeArrayCreate (VT_VARIANT, 1, arraybound); // 1-dimensionales array anlegen
	return TRUE;
}



BOOL CDbolewrapCtrl::ArraySetElement(VARIANT FAR* ArrVar, long Index, const VARIANT FAR& Data)
{
	long ix[1] ;

	ix[0]=Index-1 ;

	if (!_CheckVariant (ArrVar, "ArrVar"))
		return FALSE ;
	
	
	if (!_SafeArrayCheckBounds (ArrVar->parray, ix[0]))
		return FALSE ;
	
	VARIANT *NewVal = new VARIANT ;
	VariantInit    (NewVal);
	VariantCopyInd (NewVal, (struct tagVARIANT*) &Data);
	
	SafeArrayPutElement (ArrVar->parray, ix, NewVal);
	return TRUE;
}


BOOL CDbolewrapCtrl::SetParamFromVar(long Index, VARIANT FAR* Var) 
{
	if ((Index > MAX_PARAMS) || (Index < 1)){
		::MessageBox (NULL, "Index out of bounds", "Error", 0x10010);
		return FALSE ;
	}

	if (!_CheckVariant (Var, "Var"))
		return FALSE ;
	

	VariantClear   (&Params[MAX_PARAMS - Index]);
	VariantCopyInd (&Params[MAX_PARAMS - Index], Var);
	return TRUE;
}



BOOL CDbolewrapCtrl::ArraySetElementFromVar(VARIANT FAR* ArrVar, long Index, VARIANT FAR* Var) 
{
	long ix[1] ;
	
	ix[0]=Index-1 ;	

	if (!_CheckArrVar (ArrVar, "ArrVar"))
		return FALSE ;

	if (!_CheckVariant (Var, "Var"))
		return FALSE ;
	
	if (!_SafeArrayCheckBounds (ArrVar->parray, ix[0]))
		return FALSE ;
    
	SafeArrayPutElement (ArrVar->parray, ix, Var);
	return TRUE;
}



BOOL CDbolewrapCtrl::GetProperty(VARIANT FAR* ClassVar, LPCTSTR PropertyName, VARIANT FAR* PropertyValue) 
{
	USES_CONVERSION;
	IDispatch *idApp ;
	DISPPARAMS DispParams = {NULL, NULL, 0, 0} ;

	if (!_CheckClassVar (ClassVar, "ClassVar"))
		return FALSE ;
	
		
	idApp = ClassVar->pdispVal; 
	
	LPOLESTR osPropertyName ;
	osPropertyName = T2OLE (PropertyName) ;

	if (!_DispInvokeByName (idApp, osPropertyName, DISPATCH_PROPERTYGET, &DispParams, PropertyValue)) {
		return FALSE ;
	}
	
	return TRUE;
}

BOOL CDbolewrapCtrl::ArrayGetElement(VARIANT FAR* ArrVar, long Index, VARIANT FAR* DataVar) 
{
	long ix[1] ;

	ix[0]=Index-1 ;

	if (!_CheckArrVar (ArrVar, "ArrVar"))
		return FALSE ;
	
	if (!_SafeArrayCheckBounds (ArrVar->parray, ix[0]))
		return FALSE ;
	
	SafeArrayGetElement (ArrVar->parray, ix, DataVar);	
	return TRUE;
}



long CDbolewrapCtrl::GetVariantType(VARIANT FAR* VarAdr) 
{
	return (VarAdr->vt);
}
