
BOOL _SafeArrayCheckBounds (SAFEARRAY *SA, long TestIndex) {
	HRESULT hr ;
	long lUpperBound ;
	long lLowerBound ;

	hr = SafeArrayGetUBound (SA, 1, &lUpperBound);
	if(FAILED(hr)) {
		::MessageBox (NULL, "SafeArrayGetUBound failed", "Error", 0x10010);
		return FALSE ;
	}
    hr = SafeArrayGetLBound (SA, 1, &lLowerBound);
	if(FAILED(hr)) {
		::MessageBox (NULL, "SafeArrayGetLBound failed", "Error", 0x10010);
		return FALSE ;
	}
	if ((TestIndex > lUpperBound) || (TestIndex < lLowerBound)){
		::MessageBox (NULL, "Index of SafeArray out of bounds", "Error", 0x10010);
		return FALSE;
	}
	return TRUE ;
}



BOOL _CheckVariant (VARIANT * vVar, char* szName) {
	char Buf [200] ;

	if (vVar->vt == 0) {
		_snprintf (Buf, 100, "Variable %s has no Value", szName);
		::MessageBox (NULL, Buf, "Error", 0x10010);
		return FALSE;
	}
	return TRUE ;
}

BOOL _CheckClassVar (VARIANT *vVar, char* szName) {
	char Buf [200] ;
	if (!_CheckVariant (vVar, szName)) {
		return FALSE ;
	}
	if (vVar->vt != VT_DISPATCH) {
		_snprintf (Buf, 100, "Variable %s is not type DISPATCH", szName);
		::MessageBox (NULL, Buf, "Error", 0x10010);
		return FALSE ;
	}
	if (vVar->pdispVal == NULL) {
		_snprintf (Buf, 100, "Dispatch Value from Variable %s is NULL", szName);
		::MessageBox (NULL, Buf, "Error", 0x10010);
		return FALSE ;
	}
	return TRUE ;
}


BOOL _CheckArrVar (VARIANT *vVar, char* szName) {
	char Buf [200] ;
	if (!_CheckVariant (vVar, szName)) {
		return FALSE ;
	}
	if (vVar->vt != (VT_ARRAY| VT_VARIANT)) {
		_snprintf (Buf, 100, "Variable %s is not type Array", szName);
		::MessageBox (NULL, Buf, "Error", 0x10010);
		return FALSE ;
	}
	if (vVar->parray == NULL) {
		_snprintf (Buf, 100, "Array Value from Variable %s is NULL", szName);
		::MessageBox (NULL, Buf, "Error", 0x10010);
		return FALSE ;
	}
	return TRUE ;
}

	

   
// Taken from: http://support.microsoft.com/default.aspx?scid=kb;en-us;216686
BOOL _DispInvokeByName (IDispatch *pIDisp, LPOLESTR rgszName, WORD wDispFlags, DISPPARAMS *DispParams, VARIANT FAR* ReturnVar) {
    HRESULT hr;
    char buf[200];
    char szName[200];
	DISPID DispId ;

    // Get DISPID for name passed...
    hr = pIDisp->GetIDsOfNames(IID_NULL, &rgszName, 1, LOCALE_USER_DEFAULT, &DispId);
    if(FAILED(hr)) {
		WideCharToMultiByte(CP_ACP, 0, rgszName, -1, szName, 256, NULL, NULL);
        _snprintf(buf, 200, "Method/Propertyname not found (%s), Errorcode:0x%08lx", szName, hr);
        MessageBox(NULL, buf, "Error", 0x10010);
        return FALSE ;
    }
    
    
    // Make the call!
    hr = pIDisp->Invoke(DispId, IID_NULL, LOCALE_SYSTEM_DEFAULT, wDispFlags, DispParams, ReturnVar, NULL, NULL);
    if(FAILED(hr)) {
		WideCharToMultiByte(CP_ACP, 0, rgszName, -1, szName, 256, NULL, NULL);
        _snprintf(buf, 200, "Invoke of %s failed, Errorcode 0x%08lx", szName, hr);
        MessageBox(NULL, buf, "AutoWrap()", 0x10010);
         return FALSE;
    }
    return TRUE ;
}